#include "WonXP.h"
#include "etc.h"

#include "wonx/disp.h"
#include "wonx/system.h"
#include "wonx/comm.h"

static WonX wonx = NULL;

int WonX_IsCreated(void)
{
  return (wonx != NULL);
}

void WonX_Create(void)
{
  if (WonX_IsCreated())
    WonX_Error("WonX_Create", "WonX has been already created.");

  wonx = (WonX)malloc(sizeof(_WonX));
  if (wonx == NULL) WonX_Error("WonX_Create", "Cannot allocate memory.");

  /*
   * WonX Υޤϥǥץ쥤ΥեåʤɤδؿƤӽФᡤ
   * WonXSystem_Create() ǥޤ򥹥Ȥ WonXDisplay_Create() 
   * WonXDisplay ֥ȤƤɬפ롥Τ
   * WonXDisplay_Create()  WonXSystem_Create() θ˻äƤäƤϤʤ
   */
  wonx->wonx_display =
    WonXDisplay_Create(LCD_PIXEL_WIDTH * 2, LCD_PIXEL_HEIGHT * 2,
                       LCD_PIXEL_WIDTH, LCD_PIXEL_HEIGHT,
		       SCREEN_CHAR_WIDTH, SCREEN_CHAR_HEIGHT);

  /*
   * WonXDisplay ƱͤΤȤ WonXSerialPort Ǥ⾭Ū˵ǽ
   * 뤫⤷ʤΤǡ WonXSerialPort_Create() ⤤
   * WonXSystem_Create() ֤Ƥ
   */
  wonx->wonx_serial_port = WonXSerialPort_Create();

  /*
   * WonXSystem_Create() Ǥϥޤ뤬ޤϤ
   * ֥ȤƤФǽ뤿ᡤޤκϰֺǸ˹Ԥ
   * ٤Ǥ롥ΤᡤWonXSystem_Create() ϰֺǸ˹Ԥ
   * (¾Υ֥Ȥκ˥ޤä硤ʤȤ
   *  ʤäƤޤ)
   */
  wonx->wonx_system = WonXSystem_Create();

  return;
}

void WonX_Destroy(void)
{
  if (!WonX_IsCreated())
    WonX_Error("WonX_Destroy", "WonX has not been created yet.");

  /*
   * WonXSystem ϥޤĤޤϤʥ֥Ȥ
   * ƤФǽ뤿ᡤֺǽ˥ޤߤɬפ롥
   * ΤᡤWonXSystem_Destroy() ϰֺǽ˹Ԥ
   * (¾Υ֥Ȥκ˥ޤä硤ʤȤ
   *  ʤäƤޤ)
   */
  if (wonx->wonx_system)
    wonx->wonx_system = WonXSystem_Destroy(wonx->wonx_system);

  /*
   * WonXDisplay ƱͤΤȤ WonXSerialPort Ǥ⾭Ū˵ǽ
   * 뤫⤷ʤΤǡ WonXSerialPort_Destroy() ⤤
   * WonXSystem_Destroy() θ֤Ƥ
   */
  if (wonx->wonx_serial_port)
    wonx->wonx_serial_port = WonXSerialPort_Destroy(wonx->wonx_serial_port);

  /*
   * WonX Υޤϥǥץ쥤ΥեåʤɤδؿƤӽФᡤ
   * WonXDisplay õ WonXSystem õơޤߤ
   * ɬפ롥(Ǥʤ WonXDisplay_Destroy() μ¹˥ޤä
   * ȤˡʤȤˤʤ)
   * ΤᡤWonXDisplay_Destroy()  WonXSystem_Destroy() 
   * äƤäƤϤʤ
   */
  if (wonx->wonx_display)
    wonx->wonx_display = WonXDisplay_Destroy(wonx->wonx_display);

  free(wonx);
  wonx = NULL;

  return;
}

WonXDisplay WonX_GetWonXDisplay(void)
{
  return (wonx->wonx_display);
}

WonXSystem WonX_GetWonXSystem(void)
{
  return (wonx->wonx_system);
}

WonXSerialPort WonX_GetWonXSerialPort(void)
{
  return (wonx->wonx_serial_port);
}

/*===========================================================================*/
/* 顼                                                                */
/*===========================================================================*/

int WonX_Error(char * funcname, char * message)
{
  fprintf(stderr, "error : %s(): %s\n", funcname, message);
  exit (1);
}

int WonX_Warning(char * funcname, char * message)
{
  fprintf(stderr, "warning : %s(): %s\n", funcname, message);
  return (0);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
