#include <stdio.h>
#include <stdlib.h>

#include "wonx/wonx.h"

#include "WonX.h"
#include "WonXDisplay.h"
#include "WWDisplay.h"
#include "XDisplay.h"

#include "WWColorMap.h"
#include "WWPalette.h"
#include "WWCharacter.h"
#include "WWSprite.h"

/*****************************************************************************/
/* ˸ WonX Υӥؿ                                        */
/*****************************************************************************/

/*
 * XФȤƱȤʤʤʤɤ꤬ͤΤǡ
 * ߴؿ UNIXTimer_Pause(), UNIXTimer_Unpause() Ǥꡤ
 * ޳ߤߤƽԤޤunpause ޤˡ
 * ʤ餺 sync 褦ˤ롥
 */

/*
 * ޤΰߤΣŲ꤬ФƤΤǡ
 * ߴؿߴؿƤǤϤʤ
 * (ߤϥͥȤ뤬)
 * 褦ʽ򤹤ؿξϡɬ static ̴ؿ˽ޤȤᡤ
 * äƤӽФ褦ˤ뤳ȡ
 * ɽ⤢뤷͡
 */

/* 顼ޥå׾ν */
void wonx_print_colormap_data(void)
{
  WWDisplay ww_display;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_colormap_data() : \n");
  fflush(stdout);

  ww_display = WonXDisplay_GetWWDisplay(WonX_GetWonXDisplay());
  WWColorMap_PrintData(WWDisplay_GetColorMap(ww_display), stdout);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_colormap_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ѥåȾνؿ */
static void _print_palette_data(int n)
{
  WWDisplay ww_display;
  WWPalette ww_palette;
  ww_display = WonXDisplay_GetWWDisplay(WonX_GetWonXDisplay());
  ww_palette = WWDisplay_GetPalette(ww_display, n);
  WWPalette_PrintData(ww_palette, ww_display, stdout);
  return;
}

/* ѥåȾν */
void wonx_print_palette_data(int n)
{
  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_palette_data() : number = %d\n", n);
  fflush(stdout);

  if ((n < 0) || (n > 16 - 1))
    WonX_Error("wonx_print_palette_data", "number is out of range.");
  _print_palette_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_palette_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ٤ƤΥѥåȾ */
void wonx_print_all_palette_data(void)
{
  int n;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_all_palette_data() : \n");
  fflush(stdout);

  for (n = 0; n < 16; n++) _print_palette_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_all_palette_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* 饯νؿ */
static void _print_character_data(int n)
{
  WWDisplay ww_display;
  WWCharacter ww_character;
  ww_display = WonXDisplay_GetWWDisplay(WonX_GetWonXDisplay());
  ww_character = WWDisplay_GetCharacter(ww_display, n);
  WWCharacter_PrintData(ww_character, ww_display, stdout);
  return;
}

/* 饯ν */
void wonx_print_character_data(int n)
{
  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_character_data() : number = %d\n", n);
  fflush(stdout);

  if ((n < 0) || (n > 512 - 1))
    WonX_Error("wonx_print_character_data", "number is out of range.");
  _print_character_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_character_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ٤ƤΥ饯 */
void wonx_print_all_character_data(void)
{
  int n;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_all_character_data() : \n");
  fflush(stdout);

  for (n = 0; n < 512; n++) _print_character_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_all_character_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ץ饤Ⱦνؿ */
static void _print_sprite_data(int n)
{
  WWDisplay ww_display;
  WWSprite ww_sprite;
  ww_display = WonXDisplay_GetWWDisplay(WonX_GetWonXDisplay());
  ww_sprite = WWDisplay_GetSprite(ww_display, n);
  WWSprite_PrintData(ww_sprite, stdout);
  return;
}

/* ץ饤Ⱦν */
void wonx_print_sprite_data(int n)
{
  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_sprite_data() : number = %d\n", n);
  fflush(stdout);

  if ((n < 0) || (n > 128 - 1))
    WonX_Error("wonx_print_sprite_data", "number is out of range.");
  _print_sprite_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_sprite_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ٤ƤΥץ饤Ⱦ */
void wonx_print_all_sprite_data(void)
{
  int n;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_print_all_sprite_data() : \n");
  fflush(stdout);

  for (n = 0; n < 128; n++) _print_sprite_data(n);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_print_all_sprite_data() : return value = none\n");
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return;
}

/* ߤɽ/ɽΥ٥μ(1ʾɽ0ʲɽ) */
int wonx_get_lcddraw_level(void)
{
  XDisplay x_display;
  int ret;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_get_lcddraw_level() : \n");
  fflush(stdout);

  x_display = WonXDisplay_GetXDisplay(WonX_GetWonXDisplay());
  ret = XDisplay_GetLCDDrawLevel(x_display);

  WonXDisplay_Sync(WonX_GetWonXDisplay());

  printf("call : wonx_get_lcddraw_level() : return value = %d\n", ret);
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return (ret);
}

/* ߤɽ/ɽΥ٥ */
int wonx_set_lcddraw_level(int level)
{
  XDisplay x_display;
  int ret;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_set_lcddraw_level() : level = %d\n", level);
  fflush(stdout);

  x_display = WonXDisplay_GetXDisplay(WonX_GetWonXDisplay());
  ret = XDisplay_SetLCDDrawLevel(x_display, level);

  WonXDisplay_Flush(WonX_GetWonXDisplay());

  printf("call : wonx_set_lcddraw_level() : return value = %d\n", ret);
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return (ret);
}

/* ɽ٥򲼤 */
int wonx_lcddraw_level_down(void)
{
  XDisplay x_display;
  int ret;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_lcddraw_level_down() : \n");
  fflush(stdout);

  x_display = WonXDisplay_GetXDisplay(WonX_GetWonXDisplay());
  ret = XDisplay_LCDDrawLevelDown(x_display);

  WonXDisplay_Flush(WonX_GetWonXDisplay());

  printf("call : wonx_lcddraw_level_down() : return value = %d\n", ret);
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return (ret);
}

/* ɽ٥夲 */
int wonx_lcddraw_level_up(void)
{
  XDisplay x_display;
  int ret;

  if (!WonX_IsCreated()) WonX_Create();

  /* ޤߤ */
  UNIXTimer_Pause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  printf("call : wonx_lcddraw_level_up() : \n");
  fflush(stdout);

  x_display = WonXDisplay_GetXDisplay(WonX_GetWonXDisplay());
  ret = XDisplay_LCDDrawLevelUp(x_display);

  WonXDisplay_Flush(WonX_GetWonXDisplay());

  printf("call : wonx_lcddraw_level_up() : return value = %d\n", ret);
  fflush(stdout);

  /* ޤȤ᤹ */
  UNIXTimer_Unpause(WonXSystem_GetUNIXTimer(WonX_GetWonXSystem()));

  return (ret);
}

/*****************************************************************************/
/* End of File.                                                              */
/*****************************************************************************/
